"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Chain = void 0;

var _classPrivateFieldLooseBase2 = _interopRequireDefault(require("@babel/runtime/helpers/classPrivateFieldLooseBase"));

var _classPrivateFieldLooseKey2 = _interopRequireDefault(require("@babel/runtime/helpers/classPrivateFieldLooseKey"));

var _api2 = require("@polkadot/api");

var _wasmCrypto = require("@polkadot/wasm-crypto");

// Copyright 2021-2022 @skyekiwi/s-contract authors & contributors
// SPDX-License-Identifier: Apache-2.0
var _provider = /*#__PURE__*/(0, _classPrivateFieldLooseKey2.default)("provider");

var _api = /*#__PURE__*/(0, _classPrivateFieldLooseKey2.default)("api");

class Chain {
  constructor() {
    Object.defineProperty(this, _provider, {
      writable: true,
      value: void 0
    });
    Object.defineProperty(this, _api, {
      writable: true,
      value: void 0
    });
  }

  async init() {
    const seed = process.env.TEST_SEED_PHRASE;

    if (!seed) {
      throw new Error('seed phrase not found');
    }

    await (0, _wasmCrypto.waitReady)();
    (0, _classPrivateFieldLooseBase2.default)(this, _provider)[_provider] = new _api2.WsProvider('ws://localhost:9944'); // this.#provider = new WsProvider('wss://staging.rpc.skye.kiwi');

    (0, _classPrivateFieldLooseBase2.default)(this, _api)[_api] = await _api2.ApiPromise.create({
      provider: (0, _classPrivateFieldLooseBase2.default)(this, _provider)[_provider]
    });
  }

  async disconnect() {
    await (0, _classPrivateFieldLooseBase2.default)(this, _provider)[_provider].disconnect();
  }

  async subscribeNewBlock(newBlockHook, newContractDeployHook, newCallsHook) {
    await (0, _classPrivateFieldLooseBase2.default)(this, _api)[_api].rpc.chain.subscribeNewHeads(async latestHeader => {
      // new block hook comes first
      await newBlockHook(latestHeader.number.toNumber());
      await this.subscribeNewContractsDeployed(latestHeader.hash.toHex(), newContractDeployHook);
      await this.subscribeNewContractCallToShards(latestHeader.number.toNumber(), newCallsHook);
    });
  }

  async subscribeNewContractsDeployed(blockHash, callback) {
    // const contractIds = [];
    const events = (await (0, _classPrivateFieldLooseBase2.default)(this, _api)[_api].query.system.events.at('0xe7c186bff949d346a90c18b2afa130d293a40235270f2eef87254a8a80cf862f')).toHuman();
    events.forEach(e => {
      const evt = e.event;
      console.log(evt); // if (evt.section == "sContract" && evt.method == "deploy") {
      //   contractIds.push(e.data[0].toNumber());
      // }
    });
    callback([]);
  }

  async subscribeNewContractCallToShards(blockNumber, callback) {
    const calls = await (0, _classPrivateFieldLooseBase2.default)(this, _api)[_api].query.sContract.callHistory(0, blockNumber);
    callback(calls.toJSON());
  }

}

exports.Chain = Chain;