import _classPrivateFieldLooseBase from "@babel/runtime/helpers/esm/classPrivateFieldLooseBase";
import _classPrivateFieldLooseKey from "@babel/runtime/helpers/esm/classPrivateFieldLooseKey";
// Copyright 2021-2022 @skyekiwi/s-contract authors & contributors
// SPDX-License-Identifier: Apache-2.0
import { ApiPromise, WsProvider } from '@polkadot/api';
import { waitReady } from '@polkadot/wasm-crypto';

var _provider = /*#__PURE__*/_classPrivateFieldLooseKey("provider");

var _api = /*#__PURE__*/_classPrivateFieldLooseKey("api");

export class Chain {
  constructor() {
    Object.defineProperty(this, _provider, {
      writable: true,
      value: void 0
    });
    Object.defineProperty(this, _api, {
      writable: true,
      value: void 0
    });
  }

  async init() {
    const seed = process.env.TEST_SEED_PHRASE;

    if (!seed) {
      throw new Error('seed phrase not found');
    }

    await waitReady();
    _classPrivateFieldLooseBase(this, _provider)[_provider] = new WsProvider('ws://localhost:9944'); // this.#provider = new WsProvider('wss://staging.rpc.skye.kiwi');

    _classPrivateFieldLooseBase(this, _api)[_api] = await ApiPromise.create({
      provider: _classPrivateFieldLooseBase(this, _provider)[_provider]
    });
  }

  async disconnect() {
    await _classPrivateFieldLooseBase(this, _provider)[_provider].disconnect();
  }

  async subscribeNewBlock(newBlockHook, newContractDeployHook, newCallsHook) {
    await _classPrivateFieldLooseBase(this, _api)[_api].rpc.chain.subscribeNewHeads(async latestHeader => {
      // new block hook comes first
      await newBlockHook(latestHeader.number.toNumber());
      await this.subscribeNewContractsDeployed(latestHeader.hash.toHex(), newContractDeployHook);
      await this.subscribeNewContractCallToShards(latestHeader.number.toNumber(), newCallsHook);
    });
  }

  async subscribeNewContractsDeployed(blockHash, callback) {
    // const contractIds = [];
    const events = (await _classPrivateFieldLooseBase(this, _api)[_api].query.system.events.at('0xe7c186bff949d346a90c18b2afa130d293a40235270f2eef87254a8a80cf862f')).toHuman();
    events.forEach(e => {
      const evt = e.event;
      console.log(evt); // if (evt.section == "sContract" && evt.method == "deploy") {
      //   contractIds.push(e.data[0].toNumber());
      // }
    });
    callback([]);
  }

  async subscribeNewContractCallToShards(blockNumber, callback) {
    const calls = await _classPrivateFieldLooseBase(this, _api)[_api].query.sContract.callHistory(0, blockNumber);
    callback(calls.toJSON());
  }

}